Subject: Re: bug#38226: guix pull: error: build failed: [...] ice-9/boot-9.scm:109:20: Syntax error:

From: zimoun <[email-masked]>
Date: Tue, 18 Feb 2020 14:27:40 +0100

Hi Kai,

What is the status of this bug?
Have you solved it? Any progress?

On Wed, 20 Nov 2019 at 15:30, Kai Mertens <[email-masked]> wrote:
> On Sun, 17 Nov 2019 22:14:07 +0100
> Ludovic Courtès <[email-masked]> wrote:

> > > The command “sudo -i guix --version” gives me:
> > >   guix (GNU Guix) 20170703.13
> >
> > This version predates the big ‘guix pull’ overhaul in 0.15.0 (what
> > basically makes this kind of problem much less likely to happen.)
> >
> > Thus, you need a more recent ‘guix’ to upgrade.
> >
> > One way to do that is to fetch the derivation that builds a recent Guix
> > and to build it.
> >
> > Here’s a trick to do that (for commit 57c7bfec6, on x86_64-linux):
> >
> > --8<---------------cut here---------------start------------->8---
> > $ guile -c '(use-modules (guix)) (with-store s (build-things s (list "/gnu/store/ihylk84symj8mjhp3zmy83ch2h2pl0ks-guix-57c7bfec6.drv")))'
> > $ guix build "/gnu/store/ihylk84symj8mjhp3zmy83ch2h2pl0ks-guix-57c7bfec6.drv"
> > $ /gnu/store/4zmf32hjrjjjl2xp91aldxhmsmk6ff29-guix-57c7bfec6/bin/guix pull
> > --8<---------------cut here---------------end--------------->8---
> >
> > Let me know how it goes!
>
> Puh, in respect to the sequencing mails I have to admit that it is hard
> to me to follow the discussion. So please let me ask something else in
> between: Can I make use of an existing guix derivation file or guix
> binary, available in /gnu/store?
>
> In example (on i686):
>
> The root account has this very old guix version:
>   v0.13.0-443-gde9d8f0e29

Yes, very very old! ;-)

> Whereas, my user account has a more up-to-date version:
>   bootstrap-20190815-3564-g7696af421b
> and its Generation 1 refers to:
>   v0.16.0

And do you still have an issue when pulling from there?

> # /gnu/store/b0br0mhjxcy7bzg0c2pij1vf48jf9ddj-guix-4a0b87f0e/bin/guix pull -c0
> guile: warning: failed to install locale
> hint: Consider installing the `glibc-utf8-locales' or `glibc-locales' package and defining `GUIX_LOCPATH', along these lines:
>
>      guix package -i glibc-utf8-locales
>      export GUIX_LOCPATH="$HOME/.guix-profile/lib/locale"
>
> See the "Application Setup" section in the manual, for more info.
>
>
> Migrating profile generations to '/var/guix/profiles/per-user/root'...

This message is not expected. Something is going wrongly and was wrong before.

> I guess I am back on track now, would you agree?

Yes, you seems back on track. :-)
Is it ok for you? If yes, answer to [email-masked] to
close the bug. :-)

> I wonder why guix did not use local guix derivations or binaries that
> were already available in the store. Maybe a now-a-days version of guix
> would do?

What do you mean by "did not use local derivations or binaries that
were already available in the store"? Do you have a concrete example?

> I further wonder why the guix package itself is still listed, as with a
> fresh, recent installation of guix on top of a foreign distro, guix
> itself is not listed with “guix package -l”.

The command "guix package -i guix" will install the package 'guix' in
the profile and so 'guix' will appear with "guix package -I"
It is different than installing Guix itself.

Roughly speaking, "--install guix" will install the Guile library named 'guix'.
And installing Guix itself on a foreign distro will install all the
package manager.

All the best,
simon